
import java.util.Random;

public class SegMaxSum {

    public static void main(String[] args) {
        int N = 20;
        int[] T = new int[N];

        Random rGen = new Random();

        for (int i = 0; i < N; i++) {
            T[i] = rGen.nextInt(12) - 5;
        }

        System.out.println("Przed:");
        for (int i = 0; i < N; i++) {
            System.out.format("%d ", T[i]);
        }
        System.out.println();


        // Wariant 1 - zlozonosc O(N^3)

        int max = -1;
        int max_s = -1;
        int max_e = -1;

        for (int i = 0; i < N; i++) {
            for (int j = i; j <= N; j++) {
                int s = 0;

                for (int k = i; k < j; k++) {
                    s += T[k];
                }

                if (s > max) {
                    max_s = i;
                    max_e = j;
                    max = s;
                }
            }
        }


        System.out.format("W1: Maksymalna suma: %d poczatek: %d koniec: %d\n", max, max_s, max_e - 1);

        // Wariant 2 - zlozonosc O(N^2)


        max = -1;
        max_s = -1;
        max_e = -1;

        for (int i = 0; i < N; i++) {
            int s = 0;

            for (int j = i; j < N; j++) {
                s += T[j];

                if (s > max) {
                    max_s = i;
                    max_e = j;
                    max = s;
                }
            }
        }

        System.out.format("W2: Maksymalna suma: %d początek: %d koniec: %d\n", max, max_s, max_e);

        // Wariant 3 - zlozonosc O(N)


        int min_sum = 0;
        int sum = 0;
        max = -1;
        max_s = -1;
        max_e = -1;

        for (int i = 0; i < N; i++) {
            sum += T[i];

            if (sum < min_sum) {
                min_sum = sum;
                max_s = i + 1;
            }

            if (sum - min_sum > max) {
                max_e = i;
                max = sum - min_sum;
            }
        }

        System.out.format("W3: Maksymalna suma: %d początek: %d koniec: %d\n", max, max_s, max_e);

    }
}
